#include "LightCheck.h"
#include "rm_hal_lib.h"

uint8_t LightSensor[LightSensorNum]={0};

int lastState = OK;
const uint8_t NormalLightState[LightSensorNum]={Light,Dark,Dark,Light};

//uint8_t testarry[LightSensorNum]={0,0,0,0};

void LightCheck_Init(void)
{
	LightSensor[OL]=Light_OL_RightState;              //LightSensor arrry init
	LightSensor[ML]=Light_ML_RightState;
	LightSensor[MR]=Light_MR_RightState;
	LightSensor[OR]=Light_OR_RightState;
	
	set_digital_io_dir(Light_OL,IO_INPUT);
	set_digital_io_dir(Light_ML,IO_INPUT);
	set_digital_io_dir(Light_MR,IO_INPUT);
	set_digital_io_dir(Light_OR,IO_INPUT);
	
//	set_digital_io_dir(Light_VCC,IO_OUTPUT);
//	set_digital_io_dir(Light_GND,IO_OUTPUT);

//	write_digital_io(Light_VCC,1);
//	write_digital_io(Light_GND,0);

}
/*
void LightCheck_Detect(uint8_t* copymem)  
{
	uint8_t temp=0;
	
	read_digital_io(Light_OL,&LightSensor[0]);
	read_digital_io(Light_ML,&LightSensor[1]);
	read_digital_io(Light_MR,&LightSensor[2]);
	read_digital_io(Light_OR,&LightSensor[3]);
	
	for(;temp<LightSensorNum;temp++)
	{
		copymem[temp]=LightSensor[temp];
	}
}
*/

void LightCheck_Reflect(void)
{
	  write_led_io(Light_OL_Refl,Ref_single(&LightSensor[0]));
	  write_led_io(Light_ML_Refl,Ref_single(&LightSensor[1]));
	  write_led_io(Light_MR_Refl,Ref_single(&LightSensor[2]));
	  write_led_io(Light_OR_Refl,Ref_single(&LightSensor[3]));
}

led_io_e Ref_single(uint8_t* pos)
{
	if(*pos==0)
	{return LED_OFF;}
	else
	{return LED_ON;}
}

void LightCheck_Refresh(void)
{
	read_digital_io(Light_OL,&LightSensor[0]);
	read_digital_io(Light_ML,&LightSensor[1]);
	read_digital_io(Light_MR,&LightSensor[2]);
	read_digital_io(Light_OR,&LightSensor[3]);
}

int16_t LightCheck_AlongLine(void)
{	
	LightCheck_Refresh();
  LightCheck_Reflect();

	if(isCrossLine())
	{
		//Uncompleted
		return CrossLine;
	}
	
	if(LightSensor[ML]==LightSensor[MR])
	{
		if(LightSensor[ML]!=NormalLightState[ML]) {
			if(LightSensor[OL]!=NormalLightState[OL]) {
				lastState = OutLeft;
				return OutLeft;
			}
			
			if(LightSensor[OR]!=NormalLightState[OR]) {
				lastState = OutRight;
				return OutRight;
			}

			return lastState;
		}
		return OK;
	}
	
	if(LightSensor[ML]!=NormalLightState[ML])
	{
		lastState = MidLeft;
		return MidLeft;
	}
	
	if(LightSensor[MR]!=NormalLightState[MR])
	{
		lastState = MidRight;
		return MidRight;
	}
	
	return OK;
}

int8_t isCrossLine(void)
{
	uint8_t cnt = 0;
	for(uint8_t temp=0;temp<LightSensorNum;temp++)
	{
		if(LightSensor[temp]==Dark) cnt++;
	}
	return (cnt >= 4) || ((LightSensor[OL] == Dark) && (LightSensor[OR] == Dark));
}
