#ifndef __LIGHTCHECK_H__
#define __LIGHTCHECK_H__

#include "rm_hal_lib.h"
//O -> out    M -> mid    L -> left    R -> right
#define LightSensorNum 4

//#define Light_VCC DIGI_IO6     //light sensor power port
//#define Light_GND DIGI_IO1

#define Light_OL DIGI_IO1     //light sensor gpio port
#define Light_ML DIGI_IO2
#define Light_MR DIGI_IO3
#define Light_OR DIGI_IO4

#define Light_OL_Refl LED_IO5   //light input reflect port
#define Light_ML_Refl LED_IO6
#define Light_MR_Refl LED_IO7
#define Light_OR_Refl LED_IO8

#define Light_OL_RightState 1      //light sensor normal and regular state
#define Light_ML_RightState 0
#define Light_MR_RightState 0
#define Light_OR_RightState 1

#define OL 3                      //array position
#define ML 1
#define MR 2
#define OR 0

typedef enum
{
	Dark=0,Light=1,
}LightSensorState;

typedef enum
{
	OK=0,CrossLine=1,MidLeft=100,MidRight=-100,OutLeft=200,OutRight=-200,
}LightPosState;

void LightCheck_Init(void);

//void LightCheck_Detect(uint8_t* copymem);
void LightCheck_Reflect(void);
led_io_e Ref_single(uint8_t* pos);
int8_t isCrossLine(void);
int16_t LightCheck_AlongLine(void);
void LightCheck_Refresh(void);
//void testMode(void);

#endif


