

#ifndef __EXT_PROTOCOL_H__
#define __EXT_PROTOCOL_H__

#ifdef  __cpluscplus
extern "C"
{
#endif

/* Includes ------------------------------------------------------------------*/
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include "FIFO.h"
#include "ext_protocol_crc.h"


/* Exported macro ------------------------------------------------------------*/

/**
  * @brief  protocol relate
  */
#define EXT_PROTOCOL_HEADER                 0xA5
#define EXT_PROTOCOL_HEADER_SIZE            sizeof(extHeader_t)
#define EXT_PROTOCOL_CRC16_SIZE             sizeof(crc16_t)
#define EXT_HEADER_CRC_LEN                  (EXT_PROTOCOL_HEADER_SIZE + EXT_PROTOCOL_CRC16_SIZE)
#define EXT_HEADER_CRC_CMDID_LEN            (EXT_PROTOCOL_HEADER_SIZE + EXT_PROTOCOL_CRC16_SIZE + sizeof(uint16_t))
#define EXT_HEADER_HEAD_CMDID_LEN           (EXT_PROTOCOL_HEADER_SIZE + sizeof(uint16_t))
/* Эֶ󳤶 */
#define EXT_PROTOCOL_FRAME_MAX_SIZE         128
#define EXT_PROTOCOL_CMD_MAX_NUM            20

/* ͸ݳȣעϰͷֶҪСEXT_PROTOCOL_FRAME_MAX_SIZEICRA */
#define EXT_USER_TO_SERVER_MAX_DATA_LEN     64
#define EXT_SERVER_TO_USER_MAX_DATA_LEN     32
#define EXT_CMD_ID_LEN                      2


// uint8_t     sof;
// uint16_t    length;
// uint8_t     seq_num;
// uint8_t     crc8;
// uint16_t    cmd_id;
// uint8_t     cmd_data[];
// uint16_t    crc16;

#pragma pack(push,1)
typedef struct
{
    uint8_t     sof;
    uint16_t    length;
    uint8_t     seq_num;
    uint8_t     crc8;
}extHeader_t;
#pragma pack(pop)

typedef struct
{
    FIFO_S_t      *p_fifo;
    extHeader_t   *p_head;           //ָЭͷָ
    uint16_t      data_len;          //Эݲֳ
    uint8_t       protocol_packet[EXT_PROTOCOL_FRAME_MAX_SIZE];    //Э
    uint8_t       unpack_step;
    uint16_t      index;             //УprotocolPacketд±
}extUnpackObj_t;


typedef  uint16_t crc16_t;

typedef void (*extCmdHandle_t)(uint8_t* buf, uint16_t len);
typedef void (*extSendHandler_t)(uint8_t* buf, uint16_t len);

typedef struct
{
  uint16_t          cmd_id;
  extCmdHandle_t   handler;
} extCmdHandlerTab_t;




void ExtProtocolCmdHandleTableInit(void);
void ExtProtocolTransmit(uint16_t cmd_id, void* p_buf, uint16_t len);
int  ExtProtocolCmdHandleRegister(uint16_t cmd_id, extCmdHandle_t fun_ptr);
void ExtProtocolSendDataHandleRegister(extSendHandler_t fun_ptr);
void ExtProtocolUnpackObjInit(extUnpackObj_t *p_obj, FIFO_S_t * fifo);
uint8_t  ExtProtocolUnpack(extUnpackObj_t *pObj);

#endif  //__EXT_PROTOCOL_H__

/************************ (C) COPYRIGHT 2017 DJI RoboMaster *****END OF FILE****/
