#ifndef __ARM_TASK_H__
#define __ARM_TASK_H__

#include "stm32f4xx_hal.h"

#define ARM_MIN_Y 100
#define ARM_MAX_Y 200

#define ARM_MIN_Z -35
#define ARM_MAX_Z 100

#define ARM_RC_MOVE_RATIO_Y 2
#define ARM_RC_MOVE_RATIO_Z 2

#define ARM_S3_MIN 550
#define ARM_S3_MAX 900

#define ARM_S4_MIN 500
#define ARM_S4_MAX 1800

#define ARM_S1_STORE 1250
#define ARM_S2_STORE 500


typedef struct
{
    uint16_t s_s1;
    uint16_t s_s2;

    uint16_t s_s3;
		uint16_t s_s4;
	  uint16_t s_camera;
} servo_ctrl_t;

typedef enum
{
    ARM_CLAW_CLOSE = 0,
    ARM_CLAW_OPEN = 1,
} arm_claw_e;

void arm_init(void);
void servo_ctrl(servo_ctrl_t *servo_ctrl);
void arm_angle_calc(float *pos, int *angle);
//void arm_claw_ctrl(arm_claw_e state);
void arm_pos_ctrl(float *pos);
void arm_task(const void* argu);

void arm_remote_information_get(void);

extern float arm_angle[2];
extern float arm_procotol[2];

#endif
