#ifndef __EXECUTE_TASK_H__
#define __EXECUTE_TASK_H__

#include "stm32f4xx_hal.h"
#include "rm_hal_lib.h"

#define PROCOTOL_LEN    (3 + 1)
#define UPLOAD_LEN      256

struct RobotPose {
	uint8_t r, c, dir;
};

extern struct RobotPose pose;
extern uint8_t isGoing, isCanceling;
extern uint8_t DestR, DestC, DestDir;
extern int32_t My_Yaw;

extern float bangbang_control_output;

uint8_t isRotating(void);
void execute_task(const void* argu);
void usart_callback(void);
void rfid_callback(void);
void pose_upload(void);
void RFID_ReadHandler(uint8_t* p_buf, uint16_t len);
void LightCheck_Init(void);
void auto_controller(void);

#endif


